Bug 673630

Summary: Review Request: habari - Lite blogging software
Product: [Fedora] Fedora Reporter: Jakub Jedelsky <jakub.jedelsky>
Component: Package ReviewAssignee: Nobody's working on this, feel free to take it <nobody>
Status: CLOSED CANTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: rawhideCC: fedora-package-review, mrunge, panemade, raghusiddarth
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-02-28 03:58:23 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Jakub Jedelsky 2011-01-28 19:25:09 EST
Spec URL: http://static.stderr.cz/fedora/habari/habari.spec
SRPM URL: http://static.stderr.cz/fedora/habari/habari-0.6.6-1.fc14.src.rpm

Description:
Habari is lite and easy to use blogging system written in PHP supports
SQLite, MySQL and PostgreSQL for the database backend.

I used wordpress spec file as template for this package, becouse of similarity.

This is my first package, I will be very happy if I can find a sponsor :)
Comment 1 Jakub Jedelsky 2011-01-28 19:29:41 EST
# rpmlint habari.spec 
habari.spec: W: no-%build-section
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

# rpmlint habari-0.6.6-1.fc14.src.rpm 
habari.src: W: spelling-error %description -l en_US backend -> backed, backbend, back end
habari.src: W: no-%build-section
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
Comment 2 Raghu Udiyar 2011-02-01 14:59:01 EST
Hello Jakub,

I'm not a sponsor so I can't officially review this request. Following are a few things that you can fix though :

- habari.spec: W: no-%build-section

If you run rpmlint -i you can get more details on the errors. If you do this it'll tell you to add the %build section even if it's not needed.

- habari.src: W: spelling-error %description -l en_US backend -> backed,

You can just change the word to "back end" or "back-end" to remove this warning. Also, I think you missed a full stop before "supports" in the description.

I know it's trivial but better to get a clean rpmlint run :)
Comment 3 Jakub Jedelsky 2011-02-01 17:10:39 EST
Hello Raghu,

thanks for your hints. I didn't know, that empty build section is ok; now I'm a little bit smarter :) I made some changes. New files are here:

SPEC: http://static.stderr.cz/fedora/habari/0.6.6-2/habari.spec
SRPM: http://static.stderr.cz/fedora/habari/0.6.6-2/habari-0.6.6-2.fc14.src.rpm

rpmlint is happy now :)
Comment 4 Raghu Udiyar 2011-02-03 14:32:22 EST
Hi Jakub,

Again, an Unofficial review, but now I'll go through all the review guidelines :

-------------
 MUST Items :
-------------

- MUST: rpmlint must be run on every package. The output should be posted in the review.

Good.

- MUST: The package must be named according to the Package Naming Guidelines.

Good.

- MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption on Package Naming Guidelines

Good.

- MUST: The package must meet the Packaging Guidelines .

==> Can you consider moving the 'sed' commands to the %build section? -- just a suggestion

==> The latest change log has a typo, remove "Initial build" :

* Tue Feb 02 2011 Jakub Jedelsky <jakub.jedelsky@gmail.com> - 0.6.6-2
- Initial build
- Add empty build section
- Change Summary and description
[..]

- MUST: The package must be licensed with a Fedora approved license and 
meet the Licensing Guidelines .

Good.

- MUST: The License field in the package spec file must match the actual
license.

==> I think the license field earlier was correct. Why did you change it? 

From what I see, different components of the code are licensed under : ASL 2.0, MIT and BSD. In addition you can put comments in the spec file to indicate the license break down. Please See : http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#Multiple_Licensing_Scenarios


- MUST: If (and only if) the source package includes the text of the 
license(s) in its own file, then that file, containing the text of the 
license(s) for the package must be included in %doc.

Good.

- MUST: The spec file must be written in American English.

Good.

- MUST: The spec file for the package MUST be legible.

Good.

- MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL.

Good.

- MUST: The package must successfully compile and build into binary rpms on at
least one supported architecture.

Good.

- MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch.

Good.

- MUST: All build dependencies must be listed in BuildRequires, except for 
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

Good.

- MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.


==> Locale information is available in the Source : habari-0.6.6/system/locale

You have to use %find_lang to include these locales. Check this link : http://fedoraproject.org/wiki/Packaging/Guidelines#Handling_Locale_Files


- MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun.

NA.

- MUST: Packages must NOT bundle copies of system libraries.

Good.

- MUST: If the package is designed to be relocatable, the packager must state 
this fact in the request for review, along with the rationalization for 
relocation of that specific package. Without this, use of Prefix: /usr is 
considered a blocker.

NA.

- MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. Refer to the Guidelines for examples.

Good.

- MUST: A package must not contain any duplicate files in the %files listing.

Good.

- MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.

Good.

- MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} ( or $RPM_BUILD_ROOT ).

Good.

- MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines .

Good.

- MUST: The package must contain code, or permissable content. This is
described in detail in the code vs. content section of Packaging Guidelines .

Good.

- MUST: Large documentation files should go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity)

==> Some comments :

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/httpd/conf.d/habari.conf
%config(noreplace) %{_sysconfdir}/habari/config.php
%dir %{_datadir}/habari
%{_datadir}/habari/doc         <== Change this to %doc
%{_datadir}/habari/scripts
%{_datadir}/habari/system
%{_datadir}/habari/user
%{_datadir}/habari/3rdparty
%{_datadir}/habari/index.php
%{_datadir}/habari/config.php
%doc LICENCE
%doc NOTICE                  <== I guess these are not required if the whole doc folder is tagged as %doc above
%doc doc/MIT.txt
%doc doc/Tiddlywiki_License.txt


- MUST: If a package includes something as %doc, it must not affect the 
runtime of the application. To summarize: If it is in %doc, the program 
must run properly if it is not present.

Good.

- MUST: Header files must be in a -devel package.

NA.

- MUST: Static libraries must be in a -static package.

NA.

- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'
(for directory ownership and usability).

NA.

- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), 
then library files that end in .so (without suffix) must go in a -devel
package.

NA.

- MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}

NA.

- MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.

Good.

- MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in 
the %install section.

NA.

- MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon.

Good.

- MUST: All filenames in rpm packages must be valid UTF-8.

Good.

----------------
 SHOULD Items :
----------------

- SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.

Good.

- SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.

Good.

- SHOULD: The the package builds in mock.

Good.

- SHOULD: The package should compile and build into binary rpms on all
supported architectures.

==> Post a koji scratch build. See : http://fedoraproject.org/wiki/How_to_create_an_RPM_package#Testing_RPMs_you.27ve_built_.28including_rpmlint.29

- SHOULD: The package functions as described.

Good.

- SHOULD: If scriptlets are used, those scriptlets must be sane.

NA.

- SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.

NA.

- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase,
and this is usually for development purposes, so should be placed in a -devel
pkg.

NA.

- SHOULD: If the package has file dependencies outside of /etc, /bin,
/sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the
file instead of the file itself.

NA.

SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense

NA.
Comment 5 Jakub Jedelsky 2011-02-28 11:24:56 EST
Thanks a lot for you review..

- sed hint: I think, there isn't building package, just copying. sed comand "prepare" files for this, so I think it should be in %prep section.. But I'm not sure :)
- change log typo: fixed
- locale files: I spend a lot of time, but I don't what's a right way to move files with %find_lang macro. I wrote to devel list but without answer (http://lists.fedoraproject.org/pipermail/devel/2011-February/148833.html). 
 My SPEC file is with %find_lang now but rpmbuild return "warning: File listed twice" error.
- I will move doc folder in next SPEC

SPEC file: http://static.stderr.cz/fedora/habari/0.6.6-3/habari.spec
Comment 6 Matthias Runge 2012-03-02 15:14:23 EST
just two small comments:
ln -sf ../../../etc/habari/config.php ${RPM_BUILD_ROOT}%{_datadir}/habari/config.php

this will probably fail!

In order to get someone sponsor you into the packager group, you must convince a potential sponsor of your packaging knowledge. You could prove this by doing 'informal reviews'.

Please refer to: https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

You should note the bugzilla numbers of your reviews here (as a reference for your sponsor).
Comment 7 Matthias Runge 2012-05-08 03:23:51 EDT
Any Progress here?
Comment 8 Matthias Runge 2012-12-14 03:54:00 EST
Another ping, Jakub, are you still interested?
Comment 9 Jakub Jedelsky 2012-12-14 03:58:12 EST
Oh sure, I'll look at it asap. Thanks for pinging.
Comment 10 Matthias Runge 2013-09-17 07:04:18 EDT
another ping here.
Comment 11 Parag AN(पराग) 2015-01-12 03:09:36 EST
Removing FE-NEEDSPONSOR from the closed review tickets.